/* Popbiffh --- pop3 biff client html version*/
/* 2000/02/16 Ver.1.x */
/* Programmer K.Mori(COW) */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

extern int errno;

int main(argc, argv)
int argc;
char **argv;
{
  char c;
  FILE *fp;
  char ch[256],hostname[64],username[64],password[64],sstrs[64],rstrs[2048];
  char l[64],opt[3],version[10]={"1.2.0"};
  char pare1[128],pare2[128],pare3[128],pare4[128];
  char name1[64],name2[64],name3[64],name4[64];
  char valu1[64],valu2[64],valu3[64],valu4[64];
  register int i,s;
  int len,m,n,mode;
  struct hostent *hp;
  struct sockaddr_in sin;

  mode = 0;

  strcpy(ch,getenv("CONTENT_LENGTH"));
  sscanf(ch,"%d",&len);
  len++;
  fgets(ch,len,stdin);
  for(i=0;len>i;i++) {
    if(ch[i]=='&') ch[i]=' ';
  }
  sscanf(ch,"%s %s %s %s", &pare1, &pare2, &pare3, &pare4);
  for(i=0;strlen(pare1)>i;i++) {
    if(pare1[i]=='=') pare1[i]=' ';
  }
  sscanf(pare1,"%s %s", &name1 ,&valu1);
  for(i=0;strlen(pare2)>i;i++) {
    if(pare2[i]=='=') pare2[i]=' ';
  }
  sscanf(pare2,"%s %s", &name2 ,&valu2);
  for(i=0;strlen(pare3)>i;i++) {
    if(pare3[i]=='=') pare3[i]=' ';
  }
  sscanf(pare3,"%s %s", &name3 ,&valu3);
  for(i=0;strlen(pare4)>i;i++) {
    if(pare4[i]=='=') pare4[i]=' ';
  }
  sscanf(pare4,"%s %s", &name4 ,&valu4);
  if(0 == strcmp(name1,"HOST")) strcpy(hostname,valu1);
  if(0 == strcmp(name2,"HOST")) strcpy(hostname,valu2);
  if(0 == strcmp(name3,"HOST")) strcpy(hostname,valu3);
  if(0 == strcmp(name4,"HOST")) strcpy(hostname,valu4);
  if(0 == strcmp(name1,"USERAD")) strcpy(username,valu1);
  if(0 == strcmp(name2,"USERAD")) strcpy(username,valu2);
  if(0 == strcmp(name3,"USERAD")) strcpy(username,valu3);
  if(0 == strcmp(name4,"USERAD")) strcpy(username,valu4);
  if(0 == strcmp(name1,"PWD")) strcpy(password,valu1);
  if(0 == strcmp(name2,"PWD")) strcpy(password,valu2);
  if(0 == strcmp(name3,"PWD")) strcpy(password,valu3);
  if(0 == strcmp(name4,"PWD")) strcpy(password,valu4);
  if(0 == strcmp(name1,"OP")) strcpy(opt,valu1);
  if(0 == strcmp(name2,"OP")) strcpy(opt,valu2);
  if(0 == strcmp(name3,"OP")) strcpy(opt,valu3);
  if(0 == strcmp(name4,"OP")) strcpy(opt,valu4);

  /* check option */

    if (strcmp(opt,"c") == 0) mode = 1; /* set count mode */
    if (strcmp(opt,"d") == 0) mode = 2; /* set debug mode */
    if (strcmp(opt,"h") == 0) mode = 3; /* set headder mode */
    if (strcmp(opt,"r") == 0) mode = 4; /* set read mode */
    if (strcmp(opt,"k") == 0) mode = 5; /* set delete mode */

  /* print version */
  printf("Content-type: text/html\n\n<html><head><title>"
	 "popbiff result</title></head><body><h2>-%s- "
	 "Pop3 biff client(html).Ver.%s Copyright 1999(C)COW</h2><br><hr>\n"
	 ,argv[0],version);

  /* lookup the network address */
  if ((hp = gethostbyname(hostname)) == NULL) {
    fprintf(stderr, "%s: unknown host.</body></html>\n", hostname);
    exit(-1);
  }

  /* get a socket to work with. */
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("client: socket");
    exit(-1);
  }

  /* create the address we will be connecting to. */
  /* use pop3 port 110 */
  sin.sin_family = AF_INET;
  sin.sin_port = htons(110);
  bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);
  /* try to connect to the address. */
  if (connect(s, &sin, sizeof(sin)) < 0) {
    perror("client: connect");
    exit(-1);
  }

  /* open reading the socket. */
  fp = fdopen(s, "r");

  /* first read some strings. */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);
  if (mode == 2) printf("-Connected to %s<br>\n",argv[1]);

  /* send username */
  strcpy(sstrs,"USER ");
  strcat(sstrs,username);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Send username.<br>\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  /* send password */
  strcpy(sstrs,"PASS ");
  strcat(sstrs,password);
  strcat(sstrs,"\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Send password.<br>\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  /* get status */
  strcpy(sstrs,"STAT\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Get status.<br>\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);
  sscanf(rstrs,"%s %d %d",&l,&m,&n);

  /* get message */

  if ((m > 0)&&(mode > 2)&&(mode < 5)) {
    for (i=1; i<m+1 ;i++){
      printf("-%d------------------<br>\n",i);
      sprintf(sstrs,"RETR %d\r\n",i);
      send(s,sstrs,strlen(sstrs), 0);
      /* read response */
      fgets(rstrs, 2048, fp);
      if (popcheck(rstrs)) exit(-1);
      do {
	fgets(rstrs, 2048, fp);
	if(mode == 4) printf("%s<br>",rstrs);
	else {
	  if(strncmp(rstrs,"From:",5)==0) printf("%s<br>",rstrs);
	  if(strncmp(rstrs,"To:",3)==0) printf("%s<br>",rstrs);
	  if(strncmp(rstrs,"Subject:",8)==0) printf("%s<br>",rstrs);
	}
      }while(strncmp(rstrs,".",1) != 0);
    }
    printf("-end----------------<br><hr>\n");
  }
  if(mode == 5) {
    if(m > 0) {
     for(i=m;i>0;i--) {
      /* delete message */
      sprintf(sstrs,"DELE %d\r\n",i);
      send(s,sstrs,strlen(sstrs),0);
      /* read response */
      fgets(rstrs, 2048, fp);
      if (popcheck(rstrs)) exit(-1);
      printf("-Delete message %d at %s@%s -<br>\n",i,username,hostname);
     }
     m=0;
    } else printf("-Can not delete message at %s@%s -<br>\n",username,hostname);
  }
  /* quit pop3 server*/
  strcpy(sstrs,"QUIT\r\n");
  send(s,sstrs,strlen(sstrs), 0);
  if (mode == 2) printf("-Quit.<br>\n");
  /* read response */
  fgets(rstrs, 2048, fp);
  if (mode == 2) printf("%s",rstrs);
  if (popcheck(rstrs)) exit(-1);

  close(s);
  if (mode != 1) {
    printf("You have %d messages at %s@%s<br>\n</body></html>\n",m,username,hostname);
  } else {
    printf("%d\n</body></html>\n",m);
  }

  exit(0);
}

int popcheck(strs)
char strs[];
{
  if(strs[0] == '+') return 0;
  else {
    fprintf(stderr,"-ERROR Stop\n");
    return -1;
  }
}
